#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os

import ravinos as ro

cfg = ro.get_config()
config = None
coin = cfg['coins'][0]
pool = coin['pools'][0]
algo = coin['algo']

if algo == 'blake2b' and coin['name'] == 'TNET':
    algo = 'blake2b-btcc'
elif algo == 'blake2b' and coin['name'] == 'GLT':
    algo = 'blake2b-glt'
elif algo == 'lyra2rev2':
    algo = 'lyra2v2'
elif algo == 'phi1612':
    algo = 'phi'
elif algo == 'progpow' and coin['name'] == 'SERO':
    algo = 'progpow-sero'
elif algo == 'progpow' and coin['name'] == 'ERE':
    algo = 'progpow-ethercore'
elif algo == 'progpow' and coin['name'] == 'VEIL':
    algo = 'progpow-veil'
elif algo == 'sha-256':
    algo = 'sha256'
elif algo == 'sha512_256d_radiant':
    algo = 'sha512256d'
elif algo == 'pufferfish2bmb':
    algo = 'pufferfish2'

# Build arguments string
args = ' '.join(cfg['args'])

# Build command string
command = os.path.join(cfg['miner_dir'], 'wildrig-multi')

command += ' --algo {0}'.format(algo)

scheme = 'stratum+tcp://'
socket_type, stratum_type = ro.get_pool_type(pool['pool_type'])
if socket_type == ro.STRATUM_PROTO_TYPE_SSL or socket_type == ro.STRATUM_PROTO_TYPE_TLS:
    scheme = 'stratum+ssl://'

o = ro.url_parse(pool['url'])
if pool['name'] == 'luckypool':
    pool['password'] = cfg['auth_config']['worker']

if algo == 'progpow-sero':
    u = pool['user'].split(".")
    pool['user'] = u[0]
    command += ' --worker {0}'.format(cfg['auth_config']['worker'])

command += ' --url {0}{1} --user {2} --pass {3}'.format(scheme, o.netloc, pool['user'], pool['password'])


if len(args) > 0:
    command += ' ' + args

command += ' --api-port={0} --log-file={1}'.format(cfg['api_port'], cfg['log_file'])
# Run miner
ro.run(command)
