#!/usr/bin/env python
# -*- coding: utf-8 -*-


import json

import ravinos as ro

stats = ro.get_stats()

try:
    r = ro.get_http_data('http://127.0.0.1:{0}'.format(stats['api_port']))
except Exception as e:
    stats["errors"] = ['api is not available']
    ro.set_stats(stats)

resp = json.loads(r)

for i in range(0, len(stats['mpu'])):
    if len(resp['hashrate']['threads']) > i:
        stats['mpu'][i]['hash_rate1'] = resp['hashrate']['threads'][i][0]

# Shares count
try:
    if 'shares' in stats:
        stats['shares']['accepted'] = int(resp['results']['shares_good'])
        stats['shares']['rejected'] = int(resp['results']['shares_total'] - resp['results']['shares_good'])
except:
    pass

ro.set_stats(stats)
